// Q's C++ Library
// Copyright (c) 1998-1999 Hisashi HORIKAWA. All rights reserved.

// ǥХå롼

#ifndef QSLIB_DEBUG
#define QSLIB_DEBUG

#ifdef DEBUG

#include <stdlib.h>

extern void q_trace(const char* format, ...);
extern void q_trace_set_file(const char* fname);
#define TRACE q_trace
#define TRACE_SET_FILE q_trace_set_file

extern void* q_malloc(size_t size, const char* filename, int line);
extern void* q_calloc(size_t nelem, size_t elsize, const char* filename, int line);
extern void* q_realloc(void* ptr, size_t size, const char* filename, int line);
extern void* q_valloc(size_t size, const char* filename, int line);
extern void q_free(void* ptr, const char* filename, int line);
extern char* q_strdup(const char* s1, const char* filename, int line);
#define malloc(size)    q_malloc(size, __FILE__, __LINE__)
#define calloc(nelem, elsize)   q_calloc(nelem, elsize, __FILE__, __LINE__)
#define realloc(ptr, size)      q_realloc(ptr, size, __FILE__, __LINE__)
#define valloc(size)    q_valloc(size, __FILE__, __LINE__)
#define free(ptr)       q_free(ptr, __FILE__, __LINE__)
#define strdup(s1)      q_strdup(s1, __FILE__, __LINE__)

extern void* operator new(size_t size, const char* filename, int line) throw(bad_alloc);
extern void* operator new [] (size_t size, const char* filename, int line) throw(bad_alloc);
extern void operator delete(void* p) throw();
extern void operator delete [] (void* p) throw();
#define new new(__FILE__, __LINE__)
#else

inline void q_trace(const char*, ...) { }
inline void q_trace_set_file(const char*) { }
#define TRACE true ? (void) 0 : q_trace
#define TRACE_SET_FILE true ? (void) 0 : q_trace_set_file

#endif

#endif
