// Q's C++ Library
// Copyright (c) 1998-1999 Hisashi HORIKAWA. All rights reserved.

#ifndef QSLIB_WINDOW
#define QSLIB_WINDOW

#include <X11/Intrinsic.h>
#include "misc.h"

//////////////////////////////////////////////////////////////////////
// CWindow

class CWindow
{
protected:
    Widget window;
public:
    CWindow();
    virtual ~CWindow();

    virtual int setVisible(bool );
    bool isVisible() const;         // GTK_WIDGET_VISIBLE()
    virtual void add(Window child);         // gtk_container_add()
        // TODO: add(Component* )ѹ
        // ɥʤɡƥʤݡͥȤǤϤʤΤ롣
    virtual void setTitle(const char* title);  // gtk_window_set_title()
    virtual void destroy();         // gtk_object_destroy()
    virtual CPoint getLocation() const;
    virtual void setLocation(const CPoint& pt);
    virtual void setSize(int width, int height);
    virtual void setBounds(const CRect& r);

private:
    CWindow(const CWindow& );               // not implement
    CWindow& operator = (const CWindow& );  // not implement
};

//////////////////////////////////////////////////////////////////////
// PopupWindow

class PopupWindow: public CWindow
{
public:
    PopupWindow();
    virtual ~PopupWindow();
    virtual int setVisible(bool v);
};

#endif  // QSLIB_WINDOW
