// Q's Nicolatter for Linux
// Copyright (c) 1998-1999 Hisashi HORIKAWA. All rights reserved.

#include <vector>
#include <X11/Xlib.h>

using namespace std;

////////////////////////////////////////////////////////////////////////
// InputMethodListener

class InputMethodListener
{
public:
    virtual void inputMethodInstantiated() = 0;
    virtual void inputMethodDestroyed() = 0;
};

////////////////////////////////////////////////////////////////////////
// InputMethod

class InputMethod
{
    Display* disp;
    XIM im;
    typedef vector<InputMethodListener*> Listeners;
    Listeners listeners;

public:
    InputMethod();
    virtual ~InputMethod();

    bool open(Display* disp);
    void close();
    XIMStyle selectInputStyle(const XIMStyle* styles) const;
    XIM getXIM() const;
    void attachInputMethodListener(InputMethodListener* l);
    void detachInputMethodListener(InputMethodListener* l);
    bool is_open() const;

private:
    static void onImInstantiate(Display* disp, XPointer client_data, XPointer call_data);
    static void onImServerDestroy(XIM im_, InputMethod* this_, XPointer /*call_data*/);
};

